
#ifndef QGMEMU_H
#define QGMEMU_H

#include <qmainwindow.h>
#include <qpushbutton.h>

#include "Emulator.h"
#include "gmlcd.h"
#include "gmregisters.h"

class QTextEdit;

class qgmemu: public QMainWindow
{
    Q_OBJECT

public:
  qgmemu(int argc, const char* argv[]);
    ~qgmemu();

protected:
    void closeEvent( QCloseEvent* );

private slots:
    void choose();
    void load( const QString &fileName );
    void save();
    void saveAs();
    void print();

    void about();
    void aboutQt();
    void updateLcd();
    void buttonPressOrRelease();
    void pause();


private:
    QPrinter *printer;
    QTextEdit *e;
    QString filename;
    Emulator *gmini;
    GMLCD *lcd;
    GMRegisters *reg;

    QPushButton *butUp;
    QPushButton *butDown;
    QPushButton *butLeft;
    QPushButton *butCancel;
    QPushButton *butMenu;
    QPushButton *butRight;
    QPushButton *butOk;
    QPushButton *butOn;
};

class IOWatch : public QWidget {
 Q_OBJECT

 private:
  Emulator* gmini;
  int watched;
  QPushButton* buttons[8];
 public:
  IOWatch (Emulator* gmini, int watched, QWidget* parent);
  public slots:
  void modify();
  void refresh();
};

class AddrWatch : public QWidget {
 Q_OBJECT

 private:
  u16* watched;
  QPushButton* buttons[16];
 public:
  AddrWatch (QString name, u16* watched, QWidget* parent);
  public slots:
  void modify();
  void refresh();
};


#endif
