/*  Project: Open Source Gmini Tools
    file: trace.h, header file for trace.cpp 

    Copyright (C) 2004  The gmEmu Project <gmemu@donat.org>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifndef traceH
#define traceH

#include <iostream>
#include <string>
#include <fstream>
#include <vector>

#define TRACE_ADC (false)       // A/D converter
#define TRACE_IRQ (false)       // IRQ
#define TRACE_I2C (false)       // I2C
#define TRACE_I2C_TRANSFERS (false)
#define TRACE_I2S (false)        // I2S (aka IIS)
#define TRACE_AUDIO (false)      // Audio chip commands
#define TRACE_IO (false)        // io ports access
#define TRACE_DMA (false)       // dma accesses
#define TRACE_IDE (false)       // ide registers access
#define TRACE_SECT (false)      // hd sector access
#define TRACE_IDE_DATA (false)       // ide xfered data
#define TRACE_LCD (false)       // LCD
#define TRACE_FLASH (false)      // flash chip interaction

using namespace std;

class Emulator;
class Tracer {
 private:
   vector < string > events;
   Emulator *gmini;
 public:
   bool enabled;
   ofstream file;
   Tracer( Emulator * gm );

   void traceStep(  );
   ~Tracer(  ) {
      file.close(  );
   }

   void log( const char *fmt, ... )
     __attribute__ ( ( format( printf, 2, 3 ) ) );

   void logBuffer( const u8* buffer, int size );


};
#endif
