/*  Project: Open Source Gmini Tools
    file: util.h, header file for util.cpp 

    Copyright (C) 2004  The gmEmu Project <gmemu@donat.org>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifndef utilH
#define utilH
#include "types.h"
u32 lu32( const u8 * src );
u32 bu32( const u8 * src );
u16 lu16( const u8 * src );
u16 bu16( const u8 * src );
char *lu32( char *buffer, u32 val );
char *bu32( char *buffer, u32 val );
char *lu16( char *buffer, u16 val );
char *bu16( char *buffer, u16 val );
u32 chksum32( const u8 * src, u32 len );
u8 *XOR( u8 * data, u32 length, u8 * key, u32 keylength );
int max( int a, int b );
int min( int a, int b );
void inflate( const u8 * src, int slen, u8 * dest, int dlen );
int compress( const u8 * src, int slen, u8 * dest );
int strrpos( const char *str, const char c );
char *cstr( char *dest, const u8 * src, u32 len );
int loadFile( const char *filename, u8 ** buf );
int writeFile( const char *filename, const u8 * buffer, u32 length );
char *basename( char *fullname );
extern char qbuffer[128];
char *quote( const char *str );
char *fileextension( const char *fullname );

extern inline u16 swapBytes( u16 x ) {
   return ( x >> 8 ) | ( x << 8 );
}

#endif
