#include "MMIO.h"
#include "lcd_debug.h"
#include "hwgmini.h"
#include "lcd.h"

extern void icodecopy();
extern void icodesize();
extern void icodestart();

void* volatile interruptVector[16];

void cpu_setup() {

#ifndef NO_CRT1
  clear_watchdog();
  lcd_init(); // we start with this coz we're debugging.

  ////////////////////
  // Setup the CPU
  //

  // PLL0 (cpu osc. frequency)

  /*
  PLL0DATA = 0xf98;
  PLL0CON = 0x1; //activate
  do {
    asm "nop";
  } while ((PLL0CON & 0x2) == 0); // wait for stabilization

  PLL0CON = 0x5; // use as CPU clock

  */

  /////////////////////
  // configure SRAM

  /////////////////////////
  // Copy .icode to icram

    //  lcd_debugf("DMA ....");
    clear_watchdog();
  ddma_transfer(0, 0, (void*)0x40, &icodecopy, (int)&icodesize);
    
  /////////////////////
  // Timer A
  
  //lcd_debugf("TIMER ....");
  TAPRE = 0x0;
  TADATA = 0x7d0;

  TACON = 0x89;

  /////////////////////
  // Interrupt mask

    // interrupt priorities ?

    //lcd_debugf("Int. mask ....");
    IMR0 = 0;
    IMR1 = 0;

/*  IRQ0            BT INT */
/*  IRQ1           RTC INT */
/*  IRQ2            TA INT */
/*  IRQ3          TAOV INT */
/*  IRQ4            TB INT */
/*  IRQ5          TBOV INT */
/*  IRQ6            TC INT */
/*  IRQ7          TCOV INT */
/*  IRQ8           USB INT */
/*  IRQ9          PPIC INT */
/* IRQ10 UART_Rx/UART_Err/ UART_tx INT */
/* IRQ11            IIC INT */
/* IRQ12           SIO INT */
/* IRQ13           IIS0 INT */
/* IRQ14           IIS1 INT */
/* IRQ15                */


    //lcd_debugf("CRT1 Over!");
#endif
    clear_watchdog();
}


void installInterrupt(int i, void* fct) {
  interruptVector[i] = fct;
  IMR0 |= (1<<i);
}
