

#include "MMIO.h"
#include "hwgmini.h"


enum lcd_command {collo = 0x0, colhi = 0x1, line = 0xB};

void lcdCommand(enum lcd_command cmd, unsigned char arg) {
  unsigned char p0 = (cmd << 4) | (arg & 0xF);
  P2 &= 0xF7;
  P2 &= 0xDF;
  P2 &= 0xFB;
  P0 = p0;
  P2 |= 0x04;
  P2 |= 0x08;
  P2 |= 0x20;
}

void lcdData(int size, const unsigned char* data) {
  int i;
  for (i=0; i < size; i++) {
    P2 |= 0x08;
    P2 &= 0xDF;
    P2 &= 0xFB;
    P0 = data[i];
    P2 |= 0x04;
    P2 |= 0x08;
    P2 |= 0x20;
  }
}


const unsigned char msg[] = 
  {0xFF,0x10,0x10,0x10,0xFF,0, // H
   0xFF,0x91,0x91,0x91,0x91,0, // E
   0xFF,0x01,0x01,0x01,0x01,0, // L
   0xFF,0x01,0x01,0x01,0x01,0, // L
   0x7E,0x81,0x81,0x81,0x7E,0}; // O



void hello() {
  // where to print?
  lcdCommand(collo, 0);
  lcdCommand(colhi, 2);
  lcdCommand(line, 3);

  // flush data to lcd
  lcdData(sizeof(msg), msg);

}

int main() {
  unsigned int i;
  for (i = 0; i < 50000; i++) {
    clear_watchdog();
    hello();
  }
  
  return 0;
}
