
#include "MMIO.h"
#include "lcd.h"
#include "hwgmini.h"


// OPTIMIZE:
// In the following I do exactly as in the archos firmware.
// There're probably a better way (ie. do only one mask operation)

void lcd_write_command(int cmd) {
  P2 &= 0xF7;
  P2 &= 0xDF;
  P2 &= 0xFB;
  P0 = cmd;
  P2 |= 0x04;
  P2 |= 0x08;
  P2 |= 0x20;
}

void lcd_write_data( const unsigned char* data, int count ) {
  for (int i=0; i < count; i++) {
    P2 |= 0x08;
    P2 &= 0xDF;
    P2 &= 0xFB;
    P0 = data[i];
    P2 |= 0x04;
    P2 |= 0x08;
    P2 |= 0x20;
  }
}


u16 adc_chan_busy(int chan) {
  int adcon = (chan << 4) | 1;
  ADCON = adcon;

  //wait for conversion completed.
  while ((ADCON & (1 << 3)) == 0)
    ; 
  
  return ADDATA >> 6;
}


void ddma_transfer(int dir, int mem, void* intAddr, void* extAddr, int num) {
  u32 externalAddress = (u32) extAddr;
  u32 internalAddress = (u32) intAddr;
  // HW wants those two in word units.
  num /= 2;
  externalAddress /= 2;

  DDMACFG = (dir << 1) | (mem << 2);
  DDMAIADR = internalAddress;
  DDMAEADR = externalAddress;
  DDMANUM = num;
  DDMACOM |= 0x4; // start
  do {
  } while ((DDMACOM & 3) != 0);  // wait for completion  
}

void clear_watchdog() {
  // used to be:
  // clear watchog
  // WDTCON = 0x0A;

  // but is now:
  WDTEN = 0xA5; // disable watchdog.
}

