
#include "sprintf.h"
#include "lcd.h"
#include "system.h"

#define SIZE 1024

static char buffer[SIZE];

int nextchan = 6; 

void debug_wait() {
    snprintf(buffer, SIZE, "Press key (%d)", nextchan);
    lcd_puts(0, 4, buffer);    

    lcd_update();

    int val;
    do {
      clear_watchdog();
      val = adc_chan_busy(nextchan);
    } while (val > 0x300);
    

  nextchan++;
  if (nextchan > 7)
    nextchan = 6; 
}

void lcd_debugf(const char *fmt, ...)
{
    va_list ap;

    lcd_clear_display();

    va_start(ap, fmt);
    vsnprintf(buffer, SIZE, fmt, ap),
    va_end(ap);
    lcd_puts(0, 1, buffer);    
    debug_wait();
}


// procedure to check ic mem.


void load_code_buf (int* dst, int* src, int num) {
  int val;
  for (int i = 0; i < num; i++) {
    __asm__ ( "ldc %0, @%1" : "=r"(val) : "a"(src) );
    *dst = val;
    dst++;
    src++;
  }
}


void dump_code(int* look, int num) {
  int tmp[SIZE];
  load_code_buf(tmp, look, num);
  char* buf = buffer;
  //buf += snprintf("(%d)", SIZE, num);
  for (int i = 0; i<num; i++) {
    buf += snprintf(buf, buffer + SIZE - buf, "%04x", tmp[i]);
  }
  lcd_puts(0,0, buffer);
  debug_wait();
}


