


#define IOBASE (0x3f0000)
#define MMIO(t, x) (*( unsigned t*)(IOBASE+(x)))

#define P0 MMIO(char, 0x30)
#define P2 MMIO(char, 0x32)

enum lcd_command {collo = 0x0, colhi = 0x1, line = 0xB};


 void lcdCommand(enum lcd_command cmd, unsigned char arg) {
  P2 &= ~0x08;
  unsigned char p0 = (cmd << 4) | (arg & 0xF);
  P0 = p0;
}

 void lcdData(int size, const unsigned char* data) {
  P2 |= 0x08;
  int i;
  for (i=0; i < size; i++) {
    P0 = data[i];
  }
}


const unsigned char msg[] = {0xFF,0x10,0x10,0x10,0xFF,0, // H
			     0xFF,0x91,0x91,0x91,0x91,0, // E
			     0xFF,0x01,0x01,0x01,0x01,0, // L
			     0xFF,0x01,0x01,0x01,0x01,0, // L
			     0xFF,0x81,0x81,0x81,0x81,0}; // O


void hello() {
  lcdCommand(collo, 0);
  lcdCommand(colhi, 0);
  lcdCommand(line, 0);
  lcdData(sizeof(msg), msg);
}
